//___FILEHEADER___


#import "___FILEBASENAMEASIDENTIFIER___View.h"
#import "___FILEBASENAMEASIDENTIFIER___Cell"

@interface ___FILEBASENAMEASIDENTIFIER___View () <UITableViewDataSource, UITableViewDelegate,STCViewModelProtocol>

@property (nonatomic, strong) SLBaseTableView *tableView;


@end

@implementation ___FILEBASENAMEASIDENTIFIER___View
 
//MARK: - LifeCycle

- (void)dealloc {
    
    SLDebugLog(@"%@ - execute %s",NSStringFromClass([self class]),__func__);
}

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        [self setupUI];
    }
    return self;
}

- (instancetype)initWithCoder:(NSCoder *)coder  {
    
    self = [super initWithCoder:coder];
    if (self) {
        [self setupUI];
    }
    return self;
}

//MARK: - Setup

- (void)setupUI {
    [self addSubview:self.tableView];
    [self.tableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.bottom.equalTo(@0);
    }];
}

- (void)reloadData {
    
}

//MARK: - STCViewModelProtocol

- (void)reactActionWithViewModel:(id)viewModel target:(id)target {
    
}

- (void)updateValue:(id)value withViewModel:(id)viewModel target:(id)target {
    
}

//MARK: - TableView DataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 1;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    ___FILEBASENAMEASIDENTIFIER___Cell *cell = [___FILEBASENAMEASIDENTIFIER___Cell cellClassWithTableView:tableView forIndexPath:indexPath];

    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return [___FILEBASENAMEASIDENTIFIER___Cell cellHeight];
}

//MARK: - TableView Delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
}

//MARK: - Getter And Setter

- (___FILEBASENAMEASIDENTIFIER___VM *)viewModel {
    if(!_viewModel) {
        _viewModel = [[___FILEBASENAMEASIDENTIFIER___VM alloc] initWithDelegate:self];
    }
    return _viewModel;
}

- (SLBaseTableView *)tableView {
    
    if (!_tableView) {
        _tableView = [SLBaseTableView new];
        [___FILEBASENAMEASIDENTIFIER___Cell registerClassWithTableView:_cusTableView];

        _tableView.dataSource = self;
        _tableView.delegate = self;
    }
    return _tableView;
}
@end


